package ch.zhaw.gartenverwaltung.backgroundtasks;

import ch.zhaw.gartenverwaltung.backgroundtasks.weather.WeatherGradenTaskPlanner;
import ch.zhaw.gartenverwaltung.io.CropList;
import ch.zhaw.gartenverwaltung.io.HardinessZoneNotSetException;
import ch.zhaw.gartenverwaltung.io.PlantList;
import ch.zhaw.gartenverwaltung.io.TaskList;
import ch.zhaw.gartenverwaltung.models.Garden;
import ch.zhaw.gartenverwaltung.models.PlantNotFoundException;

import javax.mail.MessagingException;
import java.io.IOException;
import java.util.TimerTask;

public class BackgroundTasks extends TimerTask {
    private final Notifier notifier;
    private final WeatherGradenTaskPlanner weatherGardenTaskPlaner;

    public BackgroundTasks(TaskList taskList, CropList cropList, PlantList plantList) {
        notifier = new Notifier(taskList, plantList, cropList);
        weatherGardenTaskPlaner = new WeatherGradenTaskPlanner(taskList, plantList, cropList);
    }

    @Override
    public void run() {
        try {
            weatherGardenTaskPlaner.refreshTasks();
        } catch (IOException | HardinessZoneNotSetException | PlantNotFoundException e) {
            e.printStackTrace();
            // TODO logger
        }
        try {
            try {
                notifier.sendNotifications();
            } catch (MessagingException e) {
                e.printStackTrace();
                // TODO logger
            }
        } catch (IOException e) {
            e.printStackTrace();
            // TODO logger
        }
    }
}

